Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/doc/latex/NEMO/subfiles/annex_A.tex
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/doc/latex/NEMO/subfiles/annex_A.tex	(revision 10165)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/doc/latex/NEMO/subfiles/annex_A.tex	(revision 10368)
@@ -19,10 +19,11 @@
 
 In order to establish the set of Primitive Equation in curvilinear $s$-coordinates
-($i.e.$ an orthogonal curvilinear coordinate in the horizontal and an Arbitrary Lagrangian 
-Eulerian (ALE) coordinate in the vertical), we start from the set of equations established 
-in \autoref{subsec:PE_zco_Eq} for the special case $k = z$ and thus $e_3 = 1$, and we introduce 
-an arbitrary vertical coordinate $a = a(i,j,z,t)$. Let us define a new vertical scale factor by 
-$e_3 = \partial z / \partial s$ (which now depends on $(i,j,z,t)$) and the horizontal 
-slope of $s-$surfaces by :
+($i.e.$ an orthogonal curvilinear coordinate in the horizontal and
+an Arbitrary Lagrangian Eulerian (ALE) coordinate in the vertical),
+we start from the set of equations established in \autoref{subsec:PE_zco_Eq} for
+the special case $k = z$ and thus $e_3 = 1$,
+and we introduce an arbitrary vertical coordinate $a = a(i,j,z,t)$.
+Let us define a new vertical scale factor by $e_3 = \partial z / \partial s$ (which now depends on $(i,j,z,t)$) and
+the horizontal slope of $s-$surfaces by:
 \begin{equation} \label{apdx:A_s_slope}
 \sigma _1 =\frac{1}{e_1 }\;\left. {\frac{\partial z}{\partial i}} \right|_s 
@@ -31,6 +32,5 @@
 \end{equation}
 
-The chain rule to establish the model equations in the curvilinear $s-$coordinate 
-system is:
+The chain rule to establish the model equations in the curvilinear $s-$coordinate system is:
 \begin{equation} \label{apdx:A_s_chain_rule}
 \begin{aligned}
@@ -52,6 +52,6 @@
 \end{equation}
 
-In particular applying the time derivative chain rule to $z$ provides the expression 
-for $w_s$,  the vertical velocity of the $s-$surfaces referenced to a fix z-coordinate:
+In particular applying the time derivative chain rule to $z$ provides the expression for $w_s$,
+the vertical velocity of the $s-$surfaces referenced to a fix z-coordinate:
 \begin{equation} \label{apdx:A_w_in_s}
 w_s   =  \left.   \frac{\partial z }{\partial t}   \right|_s 
@@ -67,8 +67,8 @@
 \label{sec:A_continuity}
 
-Using (\autoref{apdx:A_s_chain_rule}) and the fact that the horizontal scale factors 
-$e_1$ and $e_2$ do not depend on the vertical coordinate, the divergence of 
-the velocity relative to the ($i$,$j$,$z$) coordinate system is transformed as follows
-in order to obtain its expression in the curvilinear $s-$coordinate system:
+Using (\autoref{apdx:A_s_chain_rule}) and
+the fact that the horizontal scale factors $e_1$ and $e_2$ do not depend on the vertical coordinate,
+the divergence of the velocity relative to the ($i$,$j$,$z$) coordinate system is transformed as follows in order to
+obtain its expression in the curvilinear $s-$coordinate system:
 
 \begin{subequations} 
@@ -128,12 +128,12 @@
 \end{subequations}
 
-Here, $w$ is the vertical velocity relative to the $z-$coordinate system. 
-Introducing the dia-surface velocity component, $\omega $, defined as 
-the volume flux across the moving $s$-surfaces per unit horizontal area:
+Here, $w$ is the vertical velocity relative to the $z-$coordinate system.
+Introducing the dia-surface velocity component,
+$\omega $, defined as the volume flux across the moving $s$-surfaces per unit horizontal area:
 \begin{equation} \label{apdx:A_w_s}
 \omega  = w - w_s - \sigma _1 \,u - \sigma _2 \,v    \\
 \end{equation}
-with $w_s$ given by \autoref{apdx:A_w_in_s}, we obtain the expression for 
-the divergence of the velocity in the curvilinear $s-$coordinate system:
+with $w_s$ given by \autoref{apdx:A_w_in_s},
+we obtain the expression for the divergence of the velocity in the curvilinear $s-$coordinate system:
 \begin{subequations} 
 \begin{align*} {\begin{array}{*{20}l} 
@@ -167,6 +167,5 @@
 \end{subequations}
 
-As a result, the continuity equation \autoref{eq:PE_continuity} in the 
-$s-$coordinates is:
+As a result, the continuity equation \autoref{eq:PE_continuity} in the $s-$coordinates is:
 \begin{equation} \label{apdx:A_sco_Continuity}
 \frac{1}{e_3 } \frac{\partial e_3}{\partial t} 
@@ -176,6 +175,6 @@
  +\frac{1}{e_3 }\frac{\partial \omega }{\partial s} = 0   
 \end{equation}
-A additional term has appeared that take into account the contribution of the time variation 
-of the vertical coordinate to the volume budget.
+A additional term has appeared that take into account
+the contribution of the time variation of the vertical coordinate to the volume budget.
 
 
@@ -186,5 +185,5 @@
 \label{sec:A_momentum}
 
-Here we only consider the first component of the momentum equation, 
+Here we only consider the first component of the momentum equation,
 the generalization to the second one being straightforward.
 
@@ -193,7 +192,7 @@
 $\bullet$ \textbf{Total derivative in vector invariant form}
 
-Let us consider \autoref{eq:PE_dyn_vect}, the first component of the momentum 
-equation in the vector invariant form. Its total $z-$coordinate time derivative, 
-$\left. \frac{D u}{D t} \right|_z$ can be transformed as follows in order to obtain 
+Let us consider \autoref{eq:PE_dyn_vect}, the first component of the momentum equation in the vector invariant form.
+Its total $z-$coordinate time derivative,
+$\left. \frac{D u}{D t} \right|_z$ can be transformed as follows in order to obtain
 its expression in the curvilinear $s-$coordinate system:
 
@@ -258,7 +257,6 @@
 \end{subequations}
 %
-Applying the time derivative chain rule (first equation of (\autoref{apdx:A_s_chain_rule}))
-to $u$ and using (\autoref{apdx:A_w_in_s}) provides the expression of the last term 
-of the right hand side,
+Applying the time derivative chain rule (first equation of (\autoref{apdx:A_s_chain_rule})) to $u$ and
+using (\autoref{apdx:A_w_in_s}) provides the expression of the last term of the right hand side,
 \begin{equation*} {\begin{array}{*{20}l} 
 w_s  \;\frac{\partial u}{\partial s} 
@@ -267,5 +265,5 @@
 \end{array} } 		
 \end{equation*}
-leads to the $s-$coordinate formulation of the total $z-$coordinate time derivative, 
+leads to the $s-$coordinate formulation of the total $z-$coordinate time derivative,
 $i.e.$ the total $s-$coordinate time derivative :
 \begin{align} \label{apdx:A_sco_Dt_vect}
@@ -276,7 +274,7 @@
   + \frac{1}{e_3 } \omega \;\frac{\partial u}{\partial s}   
 \end{align}
-Therefore, the vector invariant form of the total time derivative has exactly the same 
-mathematical form in $z-$ and $s-$coordinates. This is not the case for the flux form
-as shown in next paragraph.
+Therefore, the vector invariant form of the total time derivative has exactly the same mathematical form in
+$z-$ and $s-$coordinates.
+This is not the case for the flux form as shown in next paragraph.
 
 $\ $\newline    % force a new ligne
@@ -284,7 +282,6 @@
 $\bullet$ \textbf{Total derivative in flux form}
 
-Let us start from the total time derivative in the curvilinear $s-$coordinate system 
-we have just establish. Following the procedure used to establish (\autoref{eq:PE_flux_form}), 
-it can be transformed into :
+Let us start from the total time derivative in the curvilinear $s-$coordinate system we have just establish.
+Following the procedure used to establish (\autoref{eq:PE_flux_form}), it can be transformed into :
 %\begin{subequations} 
 \begin{align*} {\begin{array}{*{20}l} 
@@ -355,5 +352,5 @@
 \end{subequations}
 which leads to the $s-$coordinate flux formulation of the total $s-$coordinate time derivative, 
-$i.e.$ the total $s-$coordinate time derivative in flux form :
+$i.e.$ the total $s-$coordinate time derivative in flux form:
 \begin{flalign}\label{apdx:A_sco_Dt_flux}
 \left. \frac{D u}{D t} \right|_s   = \frac{1}{e_3}  \left. \frac{\partial ( e_3\,u)}{\partial t} \right|_s  
@@ -363,7 +360,8 @@
 \end{flalign}
 which is the total time derivative expressed in the curvilinear $s-$coordinate system.
-It has the same form as in the $z-$coordinate but for the vertical scale factor 
-that has appeared inside the time derivative which comes from the modification 
-of (\autoref{apdx:A_sco_Continuity}), the continuity equation.
+It has the same form as in the $z-$coordinate but for
+the vertical scale factor that has appeared inside the time derivative which
+comes from the modification of (\autoref{apdx:A_sco_Continuity}),
+the continuity equation.
 
 $\ $\newline    % force a new ligne
@@ -380,6 +378,6 @@
 \end{split}
 \end{equation*}
-Applying similar manipulation to the second component and replacing 
-$\sigma _1$ and $\sigma _2$ by their expression \autoref{apdx:A_s_slope}, it comes:
+Applying similar manipulation to the second component and
+replacing $\sigma _1$ and $\sigma _2$ by their expression \autoref{apdx:A_s_slope}, it comes:
 \begin{equation} \label{apdx:A_grad_p_1}
 \begin{split}
@@ -394,10 +392,11 @@
 \end{equation}
 
-An additional term appears in (\autoref{apdx:A_grad_p_1}) which accounts for the 
-tilt of $s-$surfaces with respect to geopotential $z-$surfaces.
-
-As in $z$-coordinate, the horizontal pressure gradient can be split in two parts
-following \citet{Marsaleix_al_OM08}. Let defined a density anomaly, $d$, by $d=(\rho - \rho_o)/ \rho_o$,
-and a hydrostatic pressure anomaly, $p_h'$, by $p_h'= g \; \int_z^\eta d \; e_3 \; dk$. 
+An additional term appears in (\autoref{apdx:A_grad_p_1}) which accounts for
+the tilt of $s-$surfaces with respect to geopotential $z-$surfaces.
+
+As in $z$-coordinate,
+the horizontal pressure gradient can be split in two parts following \citet{Marsaleix_al_OM08}.
+Let defined a density anomaly, $d$, by $d=(\rho - \rho_o)/ \rho_o$,
+and a hydrostatic pressure anomaly, $p_h'$, by $p_h'= g \; \int_z^\eta d \; e_3 \; dk$.
 The pressure is then given by:
 \begin{equation*} 
@@ -416,6 +415,6 @@
 \end{equation*}
 
-Substituing \autoref{apdx:A_pressure} in \autoref{apdx:A_grad_p_1} and using the definition of 
-the density anomaly it comes the expression in two parts:
+Substituing \autoref{apdx:A_pressure} in \autoref{apdx:A_grad_p_1} and
+using the definition of the density anomaly it comes the expression in two parts:
 \begin{equation} \label{apdx:A_grad_p_2}
 \begin{split}
@@ -429,13 +428,13 @@
 \end{split}
 \end{equation}
-This formulation of the pressure gradient is characterised by the appearance of a term depending on the 
-the sea surface height only (last term on the right hand side of expression \autoref{apdx:A_grad_p_2}).
-This term will be loosely termed \textit{surface pressure gradient}
-whereas the first term will be termed the 
-\textit{hydrostatic pressure gradient} by analogy to the $z$-coordinate formulation. 
-In fact, the the true surface pressure gradient is $1/\rho_o \nabla (\rho \eta)$, and 
-$\eta$ is implicitly included in the computation of $p_h'$ through the upper bound of 
-the vertical integration.
- 
+This formulation of the pressure gradient is characterised by the appearance of
+a term depending on the sea surface height only
+(last term on the right hand side of expression \autoref{apdx:A_grad_p_2}).
+This term will be loosely termed \textit{surface pressure gradient} whereas
+the first term will be termed the \textit{hydrostatic pressure gradient} by analogy to
+the $z$-coordinate formulation.
+In fact, the true surface pressure gradient is $1/\rho_o \nabla (\rho \eta)$,
+and $\eta$ is implicitly included in the computation of $p_h'$ through the upper bound of the vertical integration.
+
 
 $\ $\newline    % force a new ligne
@@ -443,7 +442,7 @@
 $\bullet$ \textbf{The other terms of the momentum equation}
 
-The coriolis and forcing terms as well as the the vertical physics remain unchanged 
-as they involve neither time nor space derivatives. The form of the lateral physics is 
-discussed in \autoref{apdx:B}.
+The coriolis and forcing terms as well as the the vertical physics remain unchanged as
+they involve neither time nor space derivatives.
+The form of the lateral physics is discussed in \autoref{apdx:B}.
 
 
@@ -452,7 +451,7 @@
 $\bullet$ \textbf{Full momentum equation}
 
-To sum up, in a curvilinear $s$-coordinate system, the vector invariant momentum equation 
-solved by the model has the same mathematical expression as the one in a curvilinear 
-$z-$coordinate, except for the pressure gradient term :
+To sum up, in a curvilinear $s$-coordinate system,
+the vector invariant momentum equation solved by the model has the same mathematical expression as
+the one in a curvilinear $z-$coordinate, except for the pressure gradient term:
 \begin{subequations} \label{apdx:A_dyn_vect}
 \begin{multline} \label{apdx:A_PE_dyn_vect_u}
@@ -475,6 +474,6 @@
 \end{multline}
 \end{subequations}
-whereas the flux form momentum equation differ from it by the formulation of both
-the time derivative and the pressure gradient term  :
+whereas the flux form momentum equation differs from it by
+the formulation of both the time derivative and the pressure gradient term:
 \begin{subequations} \label{apdx:A_dyn_flux}
 \begin{multline} \label{apdx:A_PE_dyn_flux_u}
@@ -503,11 +502,10 @@
 \end{equation}
 
-It is important to realize that the change in coordinate system has only concerned
-the position on the vertical. It has not affected (\textbf{i},\textbf{j},\textbf{k}), the 
-orthogonal curvilinear set of unit vectors. ($u$,$v$) are always horizontal velocities
-so that their evolution is driven by \emph{horizontal} forces, in particular 
-the pressure gradient. By contrast, $\omega$ is not $w$, the third component of the velocity,
-but the dia-surface velocity component, $i.e.$ the volume flux across the moving 
-$s$-surfaces per unit horizontal area. 
+It is important to realize that the change in coordinate system has only concerned the position on the vertical.
+It has not affected (\textbf{i},\textbf{j},\textbf{k}), the orthogonal curvilinear set of unit vectors.
+($u$,$v$) are always horizontal velocities so that their evolution is driven by \emph{horizontal} forces,
+in particular the pressure gradient.
+By contrast, $\omega$ is not $w$, the third component of the velocity, but the dia-surface velocity component,
+$i.e.$ the volume flux across the moving $s$-surfaces per unit horizontal area. 
 
 
@@ -518,6 +516,6 @@
 \label{sec:A_tracer}
 
-The tracer equation is obtained using the same calculation as for the continuity 
-equation and then regrouping the time derivative terms in the left hand side :
+The tracer equation is obtained using the same calculation as for the continuity equation and then
+regrouping the time derivative terms in the left hand side :
 
 \begin{multline} \label{apdx:A_tracer}
@@ -531,6 +529,6 @@
 
 
-The expression for the advection term is a straight consequence of (A.4), the 
-expression of the 3D divergence in the $s-$coordinates established above. 
+The expression for the advection term is a straight consequence of (A.4),
+the expression of the 3D divergence in the $s-$coordinates established above. 
 
 \end{document}