Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_top_cfg
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_top_cfg	(revision 10368)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_ICE_PISCES/EXPREF/namelist_top_cfg	(revision 10377)
@@ -90,4 +90,8 @@
 /
 !-----------------------------------------------------------------------
+&namtrc_snk      !  sedimentation of particles
+!-----------------------------------------------------------------------
+/
+!-----------------------------------------------------------------------
 &namtrc_dmp      !   passive tracer newtonian damping   
 !-----------------------------------------------------------------------
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_OFF_PISCES/EXPREF/namelist_top_cfg
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_OFF_PISCES/EXPREF/namelist_top_cfg	(revision 10368)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/ORCA2_OFF_PISCES/EXPREF/namelist_top_cfg	(revision 10377)
@@ -89,4 +89,8 @@
 /
 !-----------------------------------------------------------------------
+&namtrc_snk      !  sedimentation of particles
+!-----------------------------------------------------------------------
+/
+!-----------------------------------------------------------------------
 &namtrc_dmp      !   passive tracer newtonian damping   
 !-----------------------------------------------------------------------
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SHARED/namelist_pisces_ref
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SHARED/namelist_pisces_ref	(revision 10368)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SHARED/namelist_pisces_ref	(revision 10377)
@@ -51,11 +51,9 @@
    wsbio2max  =  50.      ! Big particles maximum sinking speed
    wsbio2scale =  5000.    ! Big particles length scale of sinking
-   niter1max  =  1        ! Maximum number of iterations for POC
-   niter2max  =  2        ! Maximum number of iterations for GOC
 !                         !  ln_ligand enabled
    wfep       =  0.2      ! FeP sinking speed 
    ldocp      =  1.E-4    ! Phyto ligand production per unit doc 
    ldocz      =  1.E-4    ! Zoo ligand production per unit doc 
-   lthet      =  0.5      ! Proportional loss of ligands due to Fe uptake 
+   lthet      =  1.0      ! Proportional loss of ligands due to Fe uptake 
 !                         !  ln_p5z enabled
    no3rat3    =  0.182    ! N/C ratio in zooplankton
@@ -310,5 +308,5 @@
    xlam1        =  0.005  ! scavenging rate of Iron
    xlamdust     =  150.0  ! Scavenging rate of dust
-   ligand       =  0.6E-9 ! Ligands concentration 
+   ligand       =  0.7E-9 ! Ligands concentration 
    kfep         =  0.01   ! Nanoparticle formation rate constant
 /
@@ -322,5 +320,5 @@
    xsilab    =  0.5       ! Fraction of labile biogenic silica
    feratb    =  10.E-6    ! Fe/C quota in bacteria
-   xkferb    =  2.5E-10   ! Half-saturation constant for bacteria Fe/C
+   xkferb    =  3E-10     ! Half-saturation constant for bacteria Fe/C
 !                         ! ln_p5z
    xremikc   =  0.25      ! remineralization rate of DOC
@@ -372,5 +370,5 @@
    ln_ironsed  =  .true.   ! boolean for Fe input from sediments
    ln_ironice  =  .true.   ! boolean for Fe input from sea ice
-   ln_hydrofe  =  .false.  ! boolean for from hydrothermal vents
+   ln_hydrofe  =  .true.   ! boolean for from hydrothermal vents
    sedfeinput  =  2.e-9    ! Coastal release of Iron
    distcoast   =  5.e3     ! Distance off the coast for Iron from sediments
Index: NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SHARED/namelist_top_ref
===================================================================
--- NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SHARED/namelist_top_ref	(revision 10368)
+++ NEMO/branches/2018/dev_r10164_HPC09_ESIWACE_PREP_MERGE/cfgs/SHARED/namelist_top_ref	(revision 10377)
@@ -95,4 +95,9 @@
 /
 !-----------------------------------------------------------------------
+&namtrc_snk      !  Sedimentation of particles
+!-----------------------------------------------------------------------
+   nitermax      =  2   !  number of iterations for sedimentation
+/
+!-----------------------------------------------------------------------
 &namtrc_dmp      !   passive tracer newtonian damping                   (ln_trcdmp=T)
 !-----------------------------------------------------------------------